<?php
namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Teknisa\CNC\Services;
use Teknisa\CNC\Utilities;

class TipoRecebimento extends \Zeedhi\Framework\Controller\Simple {
    
    protected $entityManager;
    protected $tiporeceService;
    protected $salesMessage;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Services\TipoRecebimento $tiporeceService, Utilities\SalesMessageCNC $salesMessage) {
        $this->entityManager   = $entityManager;
        $this->tiporeceService = $tiporeceService;
        $this->salesMessage    = $salesMessage;
    }

    public function getReceive(Request\Filter $request, Response $response){
        try {
            $row = $request->getFilterCriteria()->getConditions();
            $row["NRORG"] = $row[0]["value"];
            $row["LABELTIPORECE"] = isset($row[1]["value"]) ? $row[1]["value"] : "%%";
            $Result = $this->tiporeceService->getReceive($row);

            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('TipoReceRepo', $Result));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }
}