<?php
/**
 * Created by PhpStorm.
 * User: Moises Freitas 
 * Date: 11/08/2021
 * Time: 16:03
 */
set_time_limit(43200);
// Arquivo com a configuração das constantes utilizadas.
include('CNC_WS_CONSTS.php');

class Cnc_WS {

    private static $paymentsArray = [];
    private static $salesArray = [];
    private static $nrSeqControle = '';
    private static $accessDate;
    private static $responseDate;
    private static $nrorg;
    private static $estabelec = [];
    private static $periodIni;
    private static $periodEnd;
    private static $connProc;
    private static $Aplicativo;
    private static $rowBackCount = 0;
    
    private function __construct () {
        self::$paymentsArray     = $GLOBALS['paymentsArray'];
        self::$salesArray        = $GLOBALS['salesArray'];
        self::$nrSeqControle     = $GLOBALS['nrSeqControle'];
        self::$accessDate        = $GLOBALS['accessDate'];
        self::$responseDate      = $GLOBALS['responseDate'];
        self::$nrorg             = $GLOBALS['nrorg'];
        self::$estabelec         = $GLOBALS['estabelec'];
        self::$connProc          = $GLOBALS['connProc'];
        self::$Aplicativo        = 0;
    }

    /*
     * Estabele conexão com o serviço SOAP da VAN e faz duas requisições: uma para o relatório de vendas e outra o
     * relatório de pagamentos.
    */
    public static function executeWS () {
        try {
            // php CNC_WS.php --NRORG=1010
            // Exemplo de chamada do php para utilizar no SAAS
            //$params = getopt(null, ["NRORG:"])['NRORG'];
            $params = isset($_POST['NRORG']) ? $_POST['NRORG'] : null;
            //$params = '3212';
            echo 'Nrorg:'.$params;
            // Define a data em que o WS foi acessado
            date_default_timezone_set("America/Sao_Paulo");
            self::$accessDate = date('d/m/Y H:i:s');

	        // Define o período que o relatório vai verificar
	        // 1 - 257 days
	     
            self::$periodIni = date('d/m/Y',strtotime("-20 days"));
	        self::$periodEnd = date('d/m/Y',strtotime("+0 days"));
	        //self::$periodIni = '07/06/2022';
	        //self::$periodEnd = '07/06/2022';
	        
	        echo 'Data inicial'.self::$periodIni.'\n';
	        echo 'Data final'.self::$periodEnd.'\n';
            
            $conn = Cnc_WS::openConnectionOnDB($params);
            
            // Define o NRORG que será utilizado em toda a execução do WS
            $sql = "select nvl(decode(SYS_CONTEXT('nrorg_ctx', 'nrorg'), 0, 1, SYS_CONTEXT('nrorg_ctx', 'nrorg')), 1) NRORG from dual";
            $statement = oci_parse($conn, $sql);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            self::$nrorg = oci_fetch_assoc($statement)['NRORG'];
            oci_free_statement($statement);
            oci_close($conn);
            if (!self::$nrorg) {
                throw new \Exception("Não foi possível obter o NRORG");
            }
            
            echo 'Nrorg sys_context:'.self::$nrorg;

            // Configuração das opções de proxy. Este trecho é opcional, uma vez que não necessariamente a conexão terá um
            // proxy
            $options = [
                'proxy_host' => PROXY_HOST,
                'proxy_port' => PROXY_PORT,
                'proxy_login' => PROXY_LOGIN,
                'proxy_password' => PROXY_PASSWORD,
                'keep_alive' => true,
                'stream_context' => stream_context_create(array(
                    'ssl' => array(
                        'verify_peer' => false,
                        'verify_peer_name' => false,
                        'allow_self_signed' => true
                    )
                ))
            ];

            // Verifica se a base em questão já possuí dados replicados. No caso dessa ser a primeira execução do WS, o período que
            // será utilizado são os 30 últimos dias para fazer o preenchimento inicial da base de produção.
            if(Cnc_WS::CheckRetvenda(Cnc_WS::openConnectionOnDB(self::$nrorg)) == 0){
                
                self::$periodIni = date('d/m/Y',strtotime("-6 days"));
                self::$periodEnd = date('d/m/Y',strtotime("-1 days"));
            }
            
            // TEMP SOLUTION, quebra por pipe os id e senhas de acesso para os estabelecimentos do cliente
            if (ID_EMPRESA_CONC == 'USR_ORG_SAAS' || ID_EMPRESA_CONC == 'TESTE') {
                $conn = Cnc_WS::openConnectionOnDB(self::$nrorg);
                //$sql = "SELECT LISTAGG(IDEMPRESACNC||'|') WITHIN GROUP (ORDER BY NRORG) AS TOKENEMPRESA, LISTAGG(DSSENHACNC||'|') WITHIN GROUP (ORDER BY NRORG) AS TOKENSENHA, NRORG FROM TOKENCNC GROUP BY NRORG";
                $sql = "SELECT LISTAGG(IDEMPRESACNC||'|') WITHIN GROUP (ORDER BY IDEMPRESACNC) AS TOKENEMPRESA, LISTAGG(DSSENHACNC||'|') WITHIN GROUP (ORDER BY IDEMPRESACNC) AS TOKENSENHA, NRORG FROM TOKENCNC GROUP BY NRORG";
                $statement = oci_parse($conn, $sql);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                $tokenSenha = oci_fetch_assoc($statement);
                
                $idsEmpresaConc = explode("|", $tokenSenha['TOKENEMPRESA']);
                $passwords = explode("|", $tokenSenha['TOKENSENHA']);
                // Array pop utilizado para limpar a ultima posição do array que sempre vira como vazia.
                array_pop($idsEmpresaConc);
                array_pop($passwords);
                CNC_WS::ResolveSpecCarac($conn);
                oci_free_statement($statement);
                oci_close($conn);
                foreach ($idsEmpresaConc as $key=>$empresa) {
                    echo 'Key Empresa'.$idsEmpresaConc[$key];
                    echo 'Key Token'.$passwords[$key]."\n";
                }
                //var_dump($idsEmpresaConc);
                //var_dump($passwords);
            }else{
                $idsEmpresaConc = explode("|", ID_EMPRESA_CONC);
                $passwords = explode("|", SENHA_CONC);
            }
            
            
            // Merja os arrays em uma única e estrutura e cria um objeto com as propriedades idEmpresa e pass. Seria possível utilizar o
            // array accessInfo diretamente para o loop, ou mesmo usar os arrays idsEmpresaConc e passwords visto que eles sempre 
            // teriam o mesmo tamanho. Porém, essa opção foi escolhida para mais legibilidade e fácil substituição por um método mais 
            // eficiente em um futuro próximo.
            $accessInfo = Cnc_WS::zipTwo($idsEmpresaConc, $passwords);
            $connParams = array_map(function($data) {
                return new AccessInfoInterface($data['COMPANY'], $data['PASSWORD']);
            }, $accessInfo);
            
            // Executa as operações de consulta e inserção do WS para cada um dos estabelecimentos informados.
            foreach($connParams as $connParam) {
                $paramsVendas = [
                    'idEmpresa' => $connParam->getIdEmpresa(),
                    'senha' =>  $connParam->getPass(),
                    'dataVendaInicial' => self::$periodIni,
                    'dataVendaFinal' => self::$periodEnd
                ];
                
                // SoapClient cria a conexão com a URL do WS e fica preparada para chamar o procedimento necessário
                // A VAN atual nós fornece um WS feito com XMLSoap. Para mais informações sobre serviços soap e a documentação das
                // classes SoapClient e SoapServer e seus respectivos metódos, consulte - http://php.net/manual/en/book.soap.php
                $clientVenda = new SoapClient(VENDAS, array("keep_alive" => true));
                if (!$clientVenda) {
                    throw new \Exception("Não foi possível obter conexão para o relatório de vendas");
                }
                $clientPagto = new SoapClient(PAGAMENTOS, array("keep_alive" => true));
                if (!$clientPagto) {
                    throw new \Exception("Não foi possível obter conexão para o relatório de pagamentos\n");
                }
                
                $response = $clientVenda->__soapCall('ConsultaVenda', array($paramsVendas));
                if (!$response) {
                    throw new \Exception("Não há dados de vendas para os parâmetros filtrados");
                }
                
                // Link para a documentação da classe SimpleXMLElement - http://php.net/manual/en/class.simplexmlelement.php
                Cnc_WS::RecurseXMLSales(new SimpleXMLElement($response->ConsultaVendaResult));
                // Verificar se e array antes de entrar 
                if (is_array(self::$salesArray)) {
                    if (count(self::$salesArray) == 0) {
                        echo("Não houve retorno de vendas para a filial ".$paramsVendas["idEmpresa"]." neste dia\n");
                    }
                }else {
                    echo("Não houve retorno de vendas para a filial ".$paramsVendas["idEmpresa"]." neste dia\n");
                }
           
                // Define o date em que a resposta do WS foi recebida
                self::$responseDate = date('d/m/Y H:i:s');
                
                // Persistir o acesso para o relatório de vendas.
                $conn = Cnc_WS::openConnectionOnDB(self::$nrorg);
                Cnc_WS::session($conn);
                Cnc_WS::RegisterWSAccess($conn, 'V');
                
                
                // Persistir o relatório de vendas.;
                $bool = empty(self::$salesArray) ? true : Cnc_WS::InsertSales($conn, self::$salesArray);
                $bool ? var_dump('O relatório de Vendas foi inserido com sucesso.') : var_dump('Ocorreu um erro ao tentar inserir o relatório de Vendas.');
    
                $bool = empty(self::$nrSeqControle) ? true : Cnc_WS::replicaDadosProc($conn);
                $bool ? var_dump('A replicação de vendas foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar aplicar a replicação de Vendas.');
                
                $paramsPagamentos =  [
                    'idEmpresa' => $connParam->getIdEmpresa(),
                    'senha' =>  $connParam->getPass(),
                    'dataPagtoInicial' => self::$periodIni,
                    'dataPagtoFinal' => self::$periodEnd
                ];
    
                $response = $clientPagto->__soapCall('ConsultaPagamentos', array($paramsPagamentos));
                if (!$response) {
                    throw new \Exception("Não há dados de pagamentos para os parâmetros filtrados");
                }

                // Link para a documentação da classe SimpleXMLElement - http://php.net/manual/en/class.simplexmlelement.php
                Cnc_WS::RecurseXMLPayment(new SimpleXMLElement($response->ConsultaPagamentosResult));
                if (is_array(self::$paymentsArray)) {
                    if (count(self::$paymentsArray) == 0) {
                        echo("Não houve retorno de pagamentos para a filial ".$paramsPagamentos["idEmpresa"]." neste dia\n");
                    }
                }else {
                    echo("Não houve retorno de pagamentos para a filial ".$paramsPagamentos["idEmpresa"]." neste dia\n");
                }
                
                self::$responseDate = date('d/m/Y H:i:s');
                Cnc_WS::RegisterWSAccess($conn, 'P');
                $bool = empty(self::$paymentsArray) ? true : Cnc_WS::InsertPayments($conn, self::$paymentsArray);
                $bool ? var_dump('O relatório de Pagamentos foi inserido com sucesso.') : var_dump('Ocorreu um erro ao tentar inserir o relatório de Pagamentos.');
                
                $bool = empty(self::$nrSeqControle) ? true : Cnc_WS::replicaDadosProc($conn);
                $bool ? var_dump('A replicação do Financeiro foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar aplicar a replicação o Financeiro.');
                
                $clientVenda         = null;
                $clientPagto         = null;
                $paramsVendas        = null;
                $paramsPagamentos    = null;
                self::$salesArray    = [];
                self::$paymentsArray = [];
            }
            
            self::$connProc = $conn;
            $estabelecimentos = array_map(function($estabelec) {
                return  Cnc_WS::getNrEstabelec(self::$connProc, $estabelec);
            }, self::$estabelec);
            
            
            if (is_array($estabelecimentos)) {
                if (count($estabelecimentos) == 0) {
                    throw new \Exception("Não foram encontrados estabelecimentos para a execução da rotina de conciliação");
                }
            }else {
                throw new \Exception("Não foram encontrados estabelecimentos para a execução da rotina de conciliação");
            }
        
            echo "............. Realizando as conciliações............. \n";
            $bool = array_map(function($estabelec) {
                echo "...... Estabelecimento: ".$estabelec."\n";
                return  Cnc_WS::conciliacao(self::$connProc, $estabelec, self::$periodIni, self::$periodEnd);
            }, $estabelecimentos);

            $bool = array_reduce($bool, function($acc, $uniqueBool) {
                return $acc && $uniqueBool;
            }, true);
            
            $bool ? var_dump('A conciliação dos dados foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar executar a rotina de conciliação.');
            
            echo "............. Realizando a geração do financeiro (REC e BCO)............. \n";
            $bool = array_map(function($estabelec) {
                echo "...... Estabelecimento: ".$estabelec."\n";
                return  Cnc_WS::geraFinanceiro(self::$connProc, $estabelec);
            }, $estabelecimentos);

            $bool = array_reduce($bool, function($acc, $uniqueBool) {
                return $acc && $uniqueBool;
            }, true);
            
            $bool ? var_dump('A geração de valores do Financeiro foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar gerar os valores do Financeiro.');
            
            oci_commit($conn);
        } catch (\Exception $e) {
            echo($e->getMessage());
        }

    }

    /*
     * Gera um NRSEQUENCIAL para a tabela especifícada para ser usado em uma operação de insert.
     *
     * @param conn: oci8 connection object
     * @param tableName: nome da tabela
     * @param nrSeq: NRSEQUENCIAL inicial. O default é não passar nenhum paramêtro para que se gere o NRSEQUENCIAL imediatamente
     * anterior ao mais recente na tabela NOVO_CODIGO
     * @param nrSeqLength: tamanho do inteiro gerado. O default é 20
     * @param qtd: quantidade de códigos que serão gerados. O default é sempre 1
     * @param nrorg: número da organização. O default é null
     *
     * @return o NRSEQUENCIAL gerado pela procedure que é armazenado na variável nrSeq
     */
    private static function GenerateNrSeq ($conn, $tableName, $nrSeq = '', $nrSeqLength = 20, $qtd = 1) {
        $sql = 'CALL NOVO_CODIGO_NT(:P_CONTADOR, :P_SEQUENCIAL, :P_QTDE)';
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':P_CONTADOR', $tableName);
        oci_bind_by_name($statement, ':P_SEQUENCIAL', $nrSeq, $nrSeqLength);
        oci_bind_by_name($statement, ':P_QTDE', $qtd);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        if (!$nrSeq) {
            throw new \Exception("Não foi possível gerar chave primária para a tabela -> ".$tableName);
        }
        return $nrSeq;
    }

    private static function CheckRetvenda ($conn) {
        $sql = 'SELECT COUNT(*) FROM RETVENDAADQ';
        $statement = oci_parse($conn, $sql);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        
        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        $returnFlag = oci_fetch_row($statement)[0];
        oci_free_statement($statement);
        oci_close($conn);
        return $returnFlag;
    }
    
    /* Tentativa de Migracao pro PHP7
    * Ao migrar pro PHP7 estavamos tendo um problema pra conectar no banco sem fechar a conexao e limpar os statements
    * por isso foi criado as duas funcoes abaixo para abrir e fechar conexao no banco 
    */

    private static function openConnectionOnDB ($params) {
        // Conecta com a base de dados do sistema da Teknisa™
        // Link para a documentação das funções de OCI8 - http://php.net/manual/en/ref.oci8.php
        
        /* Conexao a ser usada quando o arquivo é aplicado no cliente  */
        if (USERNAME == 'USR_ORG_SAAS'){
            var_dump('USR_ORG_'.$params);
            $conn = oci_connect("/", "", 'USR_ORG_'.$params,"AL32UTF8", OCI_CRED_EXT);
        }else if(USERNAME == 'TESTE'){
            $conn = oci_connect('USR_ORG_3436', 'teknisa', 'dbclientes.teknisa.com/DBTESTE_DBTESTE_PDBORCL.paas.oracle.com', "AL32UTF8");
        }else{
            $conn = oci_connect("/", "", USERNAME,"AL32UTF8", OCI_CRED_EXT);
        }
            //$conn = oci_connect('USR_ORG_3094', 'teknisa', '192.168.122.5/pdborcl', "AL32UTF8");
        
        /* Conexao a ser usada quando o arquivo é aplicado para testes na Teknisa  */
        //$conn = oci_connect('USR_ORG_3212', 'teknisa', '192.168.122.5/pdborcl');

        return $conn;
    }

    /*
     * Percorre de forma recursiva a string XML retornada pelo WS, mudando a estrutura do XML para uma estrutura de array
     * associativo que é atribuída a variável $paymentsArray. A chave de cada index corresponde a tag XML presente na
     * documentação do WS.
     *
     * @param xml: string de retorno do WS
     * @param parent: opcional, o método pode receber uma string para concatenar antes do nome da tag, para que seja mais
     * clara a hierarquia das propiedades do XML. Exemplo de concatenação para o relatório de pagamentos:
     * .Pagamentos.Pagamento.IdentificadorPagamento
     */
    private static function RecurseXMLPayment ($xml) {
        $uniquePayment = [];
        $pagamentos = $xml->xpath('/Retorno/Pagamentos/Pagamento');
        foreach($pagamentos as $pagamento) {
            foreach($pagamento as $atributo => $value){
                $uniquePayment[':'.(string)$atributo] = (string)$value;
            }
            self::$paymentsArray[] = $uniquePayment;
            $uniquePayment = [];
        }
    }

    /*
     * Percorre de forma recursiva a string XML retornada pelo WS, mudando a estrutura do XML para uma estrutura de array
     * associativo que é atribuída a variável $salesArray. A chave de cada index corresponde a tag XML presente na
     * documentação do WS.
     *
     * @param xml: string de retorno do WS
     * @param parent: opcional, o método pode receber uma string para concatenar antes do nome da tag, para que seja mais
     * clara a hierarquia das propiedades do XML. Exemplo de concatenação para o relatório de vendas:
     * .Vendas.Venda.Estabelecimento
     */
    private static function RecurseXMLSales ($xml) {
        $uniqueSale = [];
        $vendas = $xml->xpath('/Retorno/Vendas/Venda');
        foreach($vendas as $venda) {
            foreach($venda as $atributo => $value){
                if (empty((array)($value))) { 
                    $uniqueSale[':'.(string)$atributo] = null;
                }else{
                    $uniqueSale[':'.(string)$atributo] = (string)$value;
                }
            }
            self::$salesArray[] = $uniqueSale;
            $uniqueSale = [];
        }
    }

    /*
     * Inseri os dados desse acesso ao WS na tabela de controle do sistema. Quando o WS é executado, a tabela CONTROLEACESWS deve
     * receber dois novos registros, uma linha com os dados da conexão quando o sistema buscou o relátorio de vendas e outra linha
     * com as informações de quando o sistema buscou o relatório de pagamentos.
     *
     * @param conn: oci8 connection object
     * @param idTipo: qual tipo de acesso foi realizado: de relatório de vendas ('V') ou relatório de pagamentos ('P')
     */
    private static function RegisterWSAccess ($conn, $idTipo) {
        try {
            // Gera o NRSEQUENCIAL para a operação de insert
            $nrSeq = Cnc_WS::GenerateNrSeq($conn, 'CONTROLEACESWS');
            // Define o valor do NRSEQCONTROLE globalmente para que ele possa ser utilizado por outros metôdos (outros
            // inserts)
            self::$nrSeqControle = (int)$nrSeq;

            // Inseri as informações de acesso
            $sql = "INSERT INTO CONTROLEACESWS (NRCTRLACESWS, IDTIPO, DTRETORNADA, DTACESSO, NRORG) VALUES (:P_NRSEQ, :P_IDTIPO, TO_DATE(:P_RESPONSEDATE,'DD/MM/YYYY HH24:MI:SS'), TO_DATE(:P_ACCESSDATE,'DD/MM/YYYY HH24:MI:SS'), :P_NRORG)";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':P_NRSEQ', $nrSeq);
            oci_bind_by_name($statement, ':P_IDTIPO', $idTipo);
            oci_bind_by_name($statement, ':P_ACCESSDATE', self::$accessDate);
            oci_bind_by_name($statement, ':P_RESPONSEDATE', self::$responseDate);
            oci_bind_by_name($statement, ':P_NRORG', self::$nrorg);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);

            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
            
            self::$rowBackCount++;
            self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_WS::makeCommit($conn) : self::$rowBackCount;
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }

    /*
     * Executa o sql para inserir o retorno de vendas do período.
     * O metódo recebe o array de vendas como paramêtro para que haja mais clareza na compreensão do propósito do metódo, apesar
     * da variável $salesArray ter escopo global na classe e poderia ser acessada sem esse paramêtro.
     *
     * @param conn: oci8 connection object
     * @param salesArray: array com o retorno das vendas
     * @return bool: booleano que sinaliza se o insert foi realizado com sucesso
     */
    private static function InsertSales ($conn, $salesArray) {
        try {
            $bool = false;
            foreach($salesArray as $sale) {
                // Define o sequencial de controle, FK da tabela de controle de acesso
                $sale[':NRCTRLACESWS'] = intval(self::$nrSeqControle);

                // Define o sequencial da adquirente baseado no nome da adquirente no relatório. O nome é utilizado pois o
                // relatório não possui nenhum campo que represente as adquirentes por um código numerico
                $sql = 'SELECT NRADQUIRENTE FROM ADQUIRENTE WHERE NMADQUIRENTE LIKE UPPER(:Adquirente)';
                $statement = oci_parse($conn, $sql);
                /* Foi identificado que todo lugar onde o oci_bind esta com o strval implicito na chamada ocorre o 502 do php sendo assim necessario tratar antes de enviar para o oci_bind*/
                $adquirentestrval = strval($sale[':Adquirente']);
                oci_bind_by_name($statement, ':Adquirente', $adquirentestrval);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                
                if($statement) {
                    $var = oci_fetch_assoc($statement);
                    if($var) {
                        $sale[':NRADQUIRENTE'] = $var['NRADQUIRENTE'];
                        $canInsertADQ = true;
                    } else {
                        echo "Não foi encontrada adquirente para a filtragem. Adquirente -> ".$sale[':Adquirente']."\n";
                        $canInsertADQ = false;
                    }
                } else {
                    echo "Não foi encontrada adquirente para a filtragem. Adquirente -> ".$sale[':Adquirente']."\n";
                    $canInsertADQ = false;
                }

                // Define o sequencial do produto baseado no campo de código do produto do relatório
                $sql = "SELECT NRPRODUTOADQ FROM PRODUTOADQ WHERE CDPRODUTOADQ = :CodigoProduto";
                $statement = oci_parse($conn, $sql);
                /* Foi identificado que todo lugar onde o oci_bind esta com o strval implicito na chamada ocorre o 502 do php sendo assim necessario tratar antes de enviar para o oci_bind*/
                $CodigoProdutostrval = strval($sale[':CodigoProduto']);
                oci_bind_by_name($statement, 'CodigoProduto', $CodigoProdutostrval);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                
                if($statement) {
                    $var = oci_fetch_assoc($statement);
                    if($var) {
                        $sale[':NRPRODUTOADQ'] = $var['NRPRODUTOADQ'];
                        $canInsertProduto = true;
                    } else {
                        echo "SALE ->  Não foi encontrado produto para a filtragem. Produto ->  ".$sale[':CodigoProduto']." Produto nao Homologado Produto ->  ".$sale[":DescricaoProduto"]."\n ";
                        $canInsertProduto = false;
                    }
                } else {
                    echo "SALE ->  Não foi encontrado produto para a filtragem. Produto ->  ".$sale[':CodigoProduto']." Produto nao Homologado Produto ->  ".$sale[":DescricaoProduto"]."\n ";
                    $canInsertProduto = false;
                }

                // Verifica se é necessário inserir o estabelecimento do relatório atual, e inseri em caso positivo
                in_array($sale[':Estabelecimento'], self::$estabelec) ? true : self::$estabelec[] = $sale[':Estabelecimento'];
            
                $sale[":ValorBruto"]     = str_replace(".", ",", floatval(($sale[":ValorBruto"])));
                $sale[":PercentualTaxa"] = str_replace(".", ",", floatval(($sale[":PercentualTaxa"])));
                $sale[":ValorTaxa"]      = str_replace(".", ",", floatval(($sale[":ValorTaxa"])));
                $sale[":ValorLiquido"]   = str_replace(".", ",", floatval(($sale[":ValorLiquido"])));
                $sale[":ValorPago"]      = str_replace(".", ",", floatval(($sale[":ValorPago"])));

                // Definição dos campos de auditoria
                $sale[':IDATIVO']       = 'S';
                $sale[':NRORG']         = self::$nrorg;
                $sale[':DTINCLUSAO']    = self::$responseDate;
                $sale[':DTULTATU']      = self::$responseDate;
                $sale[':NRORGINCLUSAO'] = self::$nrorg;

                // Concatena a data da venda ao hórario da transação para ser compatível com o formato date do banco de
                // dados oracle
                $sale[':HoraTransacao'] = $sale[':DataVenda'].' '.(isset($sale[':HoraTransacao']) ? $sale[':HoraTransacao']: '00:01:01');

                // Converte os valores do relatório para caracteres, de forma que esses valores sejam compatíveis com os valores
                // possíveis para as colunas no BD
                $sale[':Rejeitado'] = $sale[':Rejeitado'] === 'true' ? 'S' : 'N';
                $sale[':Cancelado'] = $sale[':Cancelado'] === 'true' ? 'S' : 'N';
                $sale[':Pago'] = $sale[':Pago'] === 'true' ? 'S' : 'N';

                switch ($sale[':Status']) {
                    case '1':
                        $sale[':Status'] = 'P'; /* Pago */
                        break;
                    case '2':
                        $sale[':Status'] = 'A'; /* Atrasado */
                        break;
                    case '3':
                        $sale[':Status'] = 'C'; /* Cancelado */
                        break;
                    case '4':
                        $sale[':Status'] = 'G'; /* Aguardando Pagamento */
                        break;
                }

                switch ($sale[':CodigoModalidade']) {
                    case '0':
                        $sale[':CodigoModalidade'] = 'D'; /* Débito */
                        break;
                    case '1':
                        $sale[':CodigoModalidade'] = 'C'; /* Credito a Vista */
                        break;
                    case '2':
                        $sale[':CodigoModalidade'] = 'P'; /* Crédito Parcelado */
                        break;
                    case '3':
                        $sale[':CodigoModalidade'] = 'B'; /* Beneficio */
                        break;
                    case '4':
                        self::$Aplicativo++;
                        echo  'Vendas aplicativos: '.self::$Aplicativo;
                        $sale[':CodigoModalidade'] = 'A'; /* Aplicativo, IFOOD, sera implementado em breve */
                        break;
                }

                // Se houver algum estabelecimento ainda não inserido na tabela de estabelecimento, eles devem ser inseridos
                // antes da inserção dos relatórios para que não ocorra erro de chave estrangeira não encontrada.
        		foreach (self::$estabelec as $key => $value)
        			Cnc_WS::CheckEstabelimento($conn, $value);

		
                // Troca o valor do Estabelecimento, substituindo o valor antigo que representava o código, para o nrestabelec
                // associado àquele código
                $sale[':Estabelecimento'] = Cnc_WS::getNrEstabelec($conn, $sale[':Estabelecimento']);
                
                $canInsertEstabelec = true;
                if (!$sale[':Estabelecimento']) {
                    echo "Não há número do estabelecimento \n";
                    $canInsertEstabelec = false;
                }
                
                // Atualiza a tabela de controle de acesso para saber conter qual o estabelecimento o WS está tratando
                Cnc_WS::updateControleAcessWS($conn, $sale[":NRCTRLACESWS"], $sale[":Estabelecimento"]);

                // Verifica se o CNPJ do relatório pertence a alguma filial do BD. Se sim, atualiza os campos de filial do
                // estabelecimento atual
                Cnc_WS::CheckCNPJFilial($conn, $sale[':Cnpj'], $sale[':Estabelecimento']);
                
                $sale[':Autorizacao'] = ((isset($sale[':Autorizacao'])) ? $sale[':Autorizacao']: null);
                
                // Chama o método que valida se a venda atual já está inserida
                $canInsert = Cnc_WS::validateOrigVendaInsertion($conn, $sale[':Nsu'], $sale[':Autorizacao'], $sale[':DataVenda']);
                
                if ($canInsert && ($sale[':CodigoModalidade'] != 'A') && $canInsertADQ && $canInsertProduto && $canInsertEstabelec) {
                    // Gera NRRETORIGVENDA para a linha atual
                    $nrOrigVenda = Cnc_WS::GenerateNrSeq($conn, 'RETORIGVENDA');
                    $sale[':NRRETORIGVENDA'] = intval($nrOrigVenda);
                    $sale[':Estabelecimento'] = intval($sale[':Estabelecimento']);
                    $sale[':NRADQUIRENTE'] = intval($sale[':NRADQUIRENTE']);
                    $sale[':NRPRODUTOADQ'] = intval($sale[':NRPRODUTOADQ']);
                    $sale[':Parcela'] = intval($sale[':Parcela']);
                    $sale[':TotalParcelas'] = intval($sale[':TotalParcelas']);
                    $sale[':NRORGINCLUSAO'] = intval($sale[':NRORGINCLUSAO']);
                    $sale[':NRORG'] = intval($sale[':NRORG']);
                    $sale[':NRCTRLACESWS'] = intval($sale[':NRCTRLACESWS']);
                    $sale[':Cartao'] = ((isset($sale[':Cartao'])) ? $sale[':Cartao']: null);
                    $sale[':Agencia'] = ((isset($sale[':Agencia'])) ? $sale[':Agencia']: null);
                    $sale[':Conta'] = ((isset($sale[':Conta'])) ? $sale[':Conta']: null);
                    $sale[':Banco'] = ((isset($sale[':Banco'])) ? $sale[':Banco']: null);
                    $sale[':ResumoVenda'] = ((isset($sale[':ResumoVenda'])) ? $sale[':ResumoVenda']: null);
                    $sql = "INSERT INTO RETORIGVENDA (NRRETORIGVENDA, NRCTRLACESWS, NRESTABELEC, NMADQUIRENTE, NRADQUIRENTE, CDPRODUTOADQ, NMPRODUTOADQ, NRPRODUTOADQ, IDMODALIDADE, DSMODALIDADE, DTVENDA, DTCREDITO, CDLOTEVENDA, NRAUTORIZACAO, NRCARTAOTRUNC, CDNSU, VRBRUTVENDA, VRTAXAADM, VRCOBRADOTAXA, VRLIQVENDA, NRTERMINAL, CDBANCO, CDAGENCIA, CDCONTCORR, DTHORATRANS, NRPARCELA, NRQTPARCELA, IDSTATUS, IDREJEITADO, IDCANCELADO, DTPGTO, VRLIQPGTO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO) 
                                              VALUES (TO_NUMBER(:NRRETORIGVENDA), TO_NUMBER(:NRCTRLACESWS), TO_NUMBER(:Estabelecimento), UPPER(:Adquirente), TO_NUMBER(:NRADQUIRENTE), :CodigoProduto, :DescricaoProduto, TO_NUMBER(:NRPRODUTOADQ), :CodigoModalidade, :DescricaoModalidade, TO_DATE(:DataVenda, 'DD/MM/YYYY'), TO_DATE(:DataPrevistaPagto, 'DD/MM/YYYY'), :ResumoVenda, :Autorizacao, :Cartao, :Nsu, TO_NUMBER(:ValorBruto), TO_NUMBER(:PercentualTaxa), TO_NUMBER(:ValorTaxa), TO_NUMBER(:ValorLiquido), :Terminal, :Banco, :Agencia, :Conta, TO_DATE(:HoraTransacao, 'DD/MM/YYYY HH24:MI:SS'), TO_NUMBER(:Parcela), TO_NUMBER(:TotalParcelas), :Status, :Rejeitado, :Cancelado, TO_DATE(:DataPagamento, 'DD/MM/YYYY'), TO_NUMBER(:ValorPago), TO_NUMBER(:NRORG), :IDATIVO, TO_DATE(:DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS'), TO_DATE(:DTULTATU, 'DD/MM/YYYY HH24:MI:SS'), TO_NUMBER(:NRORGINCLUSAO))";
                    $statement = oci_parse($conn, $sql);
                    // Executa os binds necessários para substituir os paramêtros pelos valores que serão gravados. Os campos Pago e
                    // Cancelamento do relatório são ignorados pois a função deles foi incorporada em uma única coluna (IDSTATUS) no
                    // nosso sistema. O campo CNPJ não é parte das colunas da tabela RETORIGVENDA
        		    //var_dump($sale);
                    foreach ($sale as $key => $value){
                        if ($key != ':Pago' && $key != ':Cnpj' && $key != ':Cnpj' && $key != ':Tid' && $key != ':Observacao' && $key != ':Cancelamento' && $key != ':Pedido'){
                            oci_bind_by_name($statement, $key, $sale[$key]);
                            /* A Ticket e a VR não informam código do lote*/
                            //var_dump($key);
                            //var_dump($value);
                            if ($key == ':Adquirente' && ($value == 'Ticket' || $value == 'VR' || $value == 'Valecard' || $value == 'Safra Pay')){
                                $strResumoVenda = ':ResumoVenda';
                                $strNULL = NULL;
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                            }
                            /* A PagSeguro não informa Agencia e conta lote*/
                            if ($key == ':Adquirente' && ($value == 'PagSeguro')){
                                $strNULL = NULL;
                                $strResumoVenda = ':ResumoVenda';
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                                $strResumoVenda = ':Agencia';
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                                $strResumoVenda = ':Conta';
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
            			    }
            			    /* Em casos que a data de pagamentno vem vazia inserimos NULL*/
                            //if ($key == ':DataPagamento' && (strlen($sale[':DataPagamento']) < 10)){
                            //    $strResumoVenda = ':DataPagamento';
                            //    $strNULL = NULL;
                            //    oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                            //}
            			    /* Ifood em alguns casos nao envia numero do cartao*/
                            if ($key == ':Adquirente' && ($value == 'Ifood')){
                                $strResumoVenda = ':Cartao';
                                $strNULL = NULL;
                                oci_bind_by_name($statement, $strResumoVenda, $strNULL);
                            }
            			}
        		    }
                    $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
                    $e = oci_error($statement);
                    if ($e) {
                        //var_dump($sale);
                        throw new \Exception($e["message"]);
                    } else {
                        self::$rowBackCount++;
                        self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_WS::makeCommit($conn) : self::$rowBackCount;
                    }
                }
            }
            
            return $bool;
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }
    
    /*
     * Verifica se na tabela RETORIGVENDA, já está inserido o registro em questão utilizando a data da venda, o NSU e o 
     * código da autorização, como parâmetros para busca da linha.
     *
     * @param conn: oci8 connection object
     * @param nsu
     * @param autorizacao
     * @param dtvenda
     *
     * @return bool: true se a o select não encontrar nenhuma linha com os dados da filtragem, false caso contrário.
     */
    private static function validateOrigVendaInsertion ($conn, $nsu, $autorizacao, $dtvenda) {
        $sql = "SELECT COUNT(*) LINHAS FROM RETORIGVENDA WHERE CDNSU = :CDNSU AND NRAUTORIZACAO = :NRAUTORIZACAO AND DTVENDA = TO_DATE(:DTVENDA, 'DD/MM/YYYY') AND NRORG = :NRORG";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':CDNSU', $nsu);
        oci_bind_by_name($statement, ':NRAUTORIZACAO', $autorizacao);
        oci_bind_by_name($statement, ':DTVENDA', $dtvenda);
        oci_bind_by_name($statement, ':NRORG', self::$nrorg);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        
        return intval(oci_fetch_assoc($statement)["LINHAS"]) == 0 ? true : false;
    }

    /*
     * Executa o sql para inserir o retorno de pagamentos do período.
     * O metódo recebe o array de pagamentos como paramêtro para que haja mais clareza na compreensão do propósito do metódo,
     * apesar da variável $paymentsArray ter escopo global na classe e poderia ser acessada sem esse paramêtro.
     *
     * @param conn: oci8 connection object
     * @param paymentsArray: array com o retorno das pagamentos
     *
     * @return bool: booleano que sinaliza se o insert foi realizado com sucesso
     */
    private static function InsertPayments ($conn, $paymentsArray) {
        try {
            $bool = false;
            foreach ($paymentsArray as $payment) {

                $payment[':NRCTRLACESWS'] = self::$nrSeqControle;

                // Define o sequencial da adquirente baseado no nome da adquirente no relatório. O nome é utilizado pois o
                // relatório não possui nenhum campo que represente as adquirentes por um código numerico
                $sql = 'SELECT NRADQUIRENTE FROM ADQUIRENTE WHERE NMADQUIRENTE LIKE UPPER(:Adquirente)';
                $statement = oci_parse($conn, $sql);
                $AdquirenteStrval = strval($payment[':Adquirente']);
                oci_bind_by_name($statement, ':Adquirente', $AdquirenteStrval);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                
                if($statement) {
                    $var = oci_fetch_assoc($statement);
                    if($var) {
                        $payment[':NRADQUIRENTE'] = $var['NRADQUIRENTE'];
                        $canInsertADQ = true;
                    } else {
                        echo "Não foi encontrada adquirente para a filtragem. Adquirente -> ".$sale[':Adquirente']."\n";
                        $canInsertADQ = false;
                    }
                } else {
                    echo "Não foi encontrada adquirente para a filtragem. Adquirente -> ".$sale[':Adquirente']."\n";
                    $canInsertADQ = false;
                }
                
                // Define o sequencial do e o código do produto baseado no campo de nome do produto do relatório
                $sql = "SELECT NRPRODUTOADQ, CDPRODUTOADQ FROM PRODUTOADQ WHERE REPLACE(REPLACE(REPLACE(REPLACE(UPPER(NMPRODUTOADQ), 'É', 'E'), 'Ç','C'), 'Ã','A'), 'Í','I') = REPLACE(REPLACE(REPLACE(REPLACE(UPPER(:TipoProduto), 'É', 'E'), 'Ç','C'), 'Ã','A'), 'Í','I')";
                $statement = oci_parse($conn, $sql);
                //$TipoProdutoStrVal = $payment[':TipoProduto'];
                $TipoProdutoStrVal = str_replace('í','i', str_replace('ã','a', str_replace('ç','c', str_replace('é', 'e', strval($payment[':TipoProduto'])))));
                $TipoProdutoStrVal = str_replace('Í','I',str_replace('Ã','A', str_replace('Ç','C', str_replace('É', 'E', strval($TipoProdutoStrVal)))));

                oci_bind_by_name($statement, ':TipoProduto', $TipoProdutoStrVal);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
                $canInsertPag = false;
                
                if($statement) {
                    $result = oci_fetch_assoc($statement);
                    if($result) {
                        $payment[':NRPRODUTOADQ'] = $result['NRPRODUTOADQ'];
                        $payment[':CDPRODUTOADQ'] = $result['CDPRODUTOADQ'];
                        $canInsertPag = true;
                    } else {
                        if (($payment[':Adquirente'] != 'VR') && ($payment[':Autorizacao'] || $payment[':NSU'])) {
                            echo "PAGAMENTO -> Não foi encontrado produto para a filtragem. Produto -> ".$payment[':TipoProduto'];
                            $canInsertPag = false;     
                        }
                    }
                } else {
                    echo "PAGAMENTO -> Não foi encontrado produto para a filtragem. Produto -> ".$payment[':TipoProduto'];
                    $canInsertPag = false;
                }

                // Calcula o valor líquido a ser pago pela adquirente e a taxa cobrada pela venda
                $payment[":ValorBruto"]    = floatval(str_replace(",", ".", $payment[':ValorBruto']));
                $payment[":Taxa"]          = floatval(str_replace(",", ".", $payment[':Taxa']));
                $payment[":ValorLiquido"]  = floatval(str_replace(",", ".", $payment[':ValorLiquido']));
                $payment[':VRLIQVENDA']    = str_replace(".", ",", floatval($payment[":ValorBruto"] - $payment[":ValorBruto"] * ($payment[":Taxa"] / 100)));
                $payment[':VRCOBRADOTAXA'] = str_replace(".", ",", floatval($payment[":ValorBruto"] - $payment[":ValorLiquido"]));
                $payment[":ValorBruto"]    = str_replace(".", ",", $payment[':ValorBruto']);
                $payment[":Taxa"]          = str_replace(".", ",", $payment[':Taxa']);
                $payment[":ValorLiquido"]  = str_replace(".", ",", $payment[':ValorLiquido']);

                // Verifica se é necessário inserir o estabelecimento do relatório atual, e inseri em caso positivo
                in_array($payment[':Estabelecimento'], self::$estabelec) ? true : self::$estabelec[] = $payment[':Estabelecimento'];

                // Definição dos campos de auditoria
                $payment[':IDATIVO']       = 'S';
                $payment[':NRORG']         = self::$nrorg;
                $payment[':DTINCLUSAO']    = self::$responseDate;
                $payment[':DTULTATU']      = self::$responseDate;
                $payment[':NRORGINCLUSAO'] = self::$nrorg;
                $payment[':NRORGULTATU']   = self::$nrorg;

                // Converte os valores do relatório para caracteres, de forma que esses valores sejam compatíveis com os valores
                // possíveis para as colunas no BD
                $payment[':Antecipacao'] = $payment[':Antecipacao'] === 'Sim' ? 'S' : 'N';

                switch ($payment[':IdTipoTransacao']) {
                    case '1':
                        $payment[':IdTipoTransacao'] = 'V'; /* Venda */
                        break;
                    case '2':
                        $payment[':IdTipoTransacao'] = 'P'; /* Pagamentos */
                        break; 
                    case '3':
                        $payment[':IdTipoTransacao'] = 'C'; /* Cancelamentos */
                        break;
                    case '4':
                        $payment[':IdTipoTransacao'] = 'D'; /* Débitos */
                        break;
                    default:
                        //echo "Ajuste Contrato a Débito :".$payment[':IdTipoTransacao']."\n";
                        $payment[':IdTipoTransacao'] = false; /* Débitos */
                        break;
                }

                // Se houver algum estabelecimento ainda não inserido na tabela de estabelecimento, eles devem ser inseridos
                // antes da inserção dos relatórios para que não ocorra erro de chave estrangeira não encontrada.
                foreach (self::$estabelec as $key => $value)
                    Cnc_WS::CheckEstabelimento($conn, $value);

                // Troca o valor do Estabelecimento, substituindo o valor antigo que representava o código, para o nrestabelec
                // associado àquele código
                $payment[':Estabelecimento'] = Cnc_WS::getNrEstabelec($conn, $payment[':Estabelecimento']);
                $canInsertEstabelec = true;
                if (!$payment[':Estabelecimento']) {
                    echo "Não há número do estabelecimento";
                    $canInsertEstabelec = false;
                }
                
                // Atualiza a tabela de controle de acesso para saber conter qual o estabelecimento o WS está tratando
                Cnc_WS::updateControleAcessWS($conn, $payment[":NRCTRLACESWS"], $payment[":Estabelecimento"]);

                // Verifica se o CNPJ do relatório pertence a alguma filial do BD. Se sim, atualiza os campos de filial do
                // estabelecimento atual
                Cnc_WS::CheckCNPJFilial($conn, $payment[':Cnpj'], $payment[':Estabelecimento']);
                
                // Chama o método que valida se o pagamento atual já está inserido
                $canInsert = Cnc_WS::validateOrigFinancInsertion($conn,
                                                                 $payment[':NSU'],
                                                                 $payment[':Autorizacao'],
                                                                 $payment[':DataPagamento'],
                                                                 $payment[':ValorBruto'],
                                                                 $payment[':ResumoVenda']);
                if ($canInsert && !!$payment[':IdTipoTransacao'] && $canInsertADQ && $canInsertPag && $canInsertEstabelec) {
                    
                    $nrOrigPgto = Cnc_WS::GenerateNrSeq($conn, 'RETORIGFINANC');
                    $payment[':NRRETORIGFINANC'] = intval($nrOrigPgto);
                    $sql = "INSERT INTO RETORIGFINANC (NRRETORIGFINANC, NRCTRLACESWS, NRESTABELEC, NMADQUIRENTE, NRADQUIRENTE, CDPRODUTOADQ, NMPRODUTOADQ, NRPRODUTOADQ, DTVENDA, DTCREDITO, CDLOTEVENDA, NRAUTORIZACAO, CDNSU, NRTID, VRBRUTVENDA, VRTAXAADM, VRCOBRADOTAXA, VRLIQVENDA, CDBANCO, CDAGENCIA, CDCONTCORR, NRPARCELA, NRQTPARCELA, IDANTECIPADO, IDTIPOTRANS, DSTRANSACAO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, NRORGULTATU ) VALUES (:NRRETORIGFINANC, :NRCTRLACESWS, :Estabelecimento, UPPER(:Adquirente), :NRADQUIRENTE, :CDPRODUTOADQ, :TipoProduto, :NRPRODUTOADQ, TO_DATE(:DataVenda, 'DD/MM/YYYY'), TO_DATE(:DataPagamento, 'DD/MM/YYYY'), :ResumoVenda, :Autorizacao, :NSU, :TID, TO_NUMBER(:ValorBruto), TO_NUMBER(:Taxa), ROUND(TO_NUMBER(:VRCOBRADOTAXA), 2), ROUND(TO_NUMBER(:VRLIQVENDA), 2), :Banco, :Agencia, :Conta, :Parcela, :TotalParcelas, :Antecipacao, :IdTipoTransacao, :TipoTransacao, :NRORG, :IDATIVO, TO_DATE(:DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS'), TO_DATE(:DTULTATU, 'DD/MM/YYYY HH24:MI:SS'), :NRORGINCLUSAO, :NRORGULTATU )";
                    $statement = oci_parse($conn, $sql);
                    
                    // Executa os binds necessários para substituir os paramêtros pelos valores que serão gravados. Alguns campos são
                    // ignorados no bind por não possuírem coluna correspondente na tabela do BD.
                    foreach ($payment as $key => $value)
                        $key === ':IdentificadorPagamento' ? true :
                            $key === ':Cnpj' ? true : // E dai q é gambiarra zé
                                $key === ':IdStatus' ? true : // Vai fala q n ficou dahora?
                                    $key === ':Status' ? true : // Já tô usando php
                                        $key === ':Divergencias' ? true : // Não tem problema escrotizar
                                            $key === ':ValorLiquido' ? true : // N fica mais zuado do q php já é
                                                oci_bind_by_name($statement, $key, $payment[$key]);
                    $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
                    $e = oci_error($statement);
                    if ($e) {
                        throw new \Exception($e["message"]);
                    } else {
                        self::$rowBackCount++;
                        self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_WS::makeCommit($conn) : self::$rowBackCount;
                    }
                }
            }

            return $bool;
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }
    
    /*
     * Verifica se na tabela RETORIGFINANC, já está inserido o registro em questão utilizando a data da venda, o NSU e o 
     * código da autorização, como parâmetros para busca da linha.
     *
     * @param conn: oci8 connection object
     * @param nsu
     * @param autorizacao
     * @param dtcredito
     *
     * @return bool: true se a o select não encontrar nenhuma linha com os dados da filtragem, false caso contrário.
     */
    private static function validateOrigFinancInsertion ($conn, $nsu, $autorizacao, $dtcredito, $vrbruto, $cdlotevenda) {
        //Garante que o formato do DTCREDITO será sempre DD/MM/YYYY
	    $dtcredito = explode('/', $dtcredito);
	    $year = $dtcredito[2];
	    if(strlen($year) != 4 ){
	       $currYear = str_split(date('Y'));
	       $currYear = $currYear[0].$currYear[1].'0'.'0';
	       $year += $currYear;
	    }
	    $dtcredito[2] = $year;
	    $dtcredito = $dtcredito[0].'/'.$dtcredito[1].'/'.$dtcredito[2];
	    
        if ($nsu == NULL && isset($cdlotevenda)) {
            $sql = "SELECT COUNT(*) LINHAS FROM RETORIGFINANC WHERE CDNSU IS NULL AND NRAUTORIZACAO IS NULL AND DTCREDITO = :DTCREDITO AND NRORG = :NRORG AND VRBRUTVENDA = :VRBRUTVENDA AND CDLOTEVENDA = :CDLOTEVENDA";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':VRBRUTVENDA', $vrbruto);
            oci_bind_by_name($statement, ':CDLOTEVENDA', $cdlotevenda);
            
        } else if (isset($nsu) && $cdlotevenda == NULL && $autorizacao == NULL){
            $sql = "SELECT COUNT(*) LINHAS FROM RETORIGFINANC WHERE CDNSU = :CDNSU AND NRAUTORIZACAO IS NULL AND CDLOTEVENDA IS NULL AND DTCREDITO = :DTCREDITO AND NRORG = :NRORG AND VRBRUTVENDA = :VRBRUTVENDA";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':CDNSU', $nsu);
            oci_bind_by_name($statement, ':VRBRUTVENDA', $vrbruto);

        } else if ($nsu == NULL && isset($autorizacao)) {
            $sql = "SELECT COUNT(*) LINHAS FROM RETORIGFINANC WHERE CDNSU IS NULL AND NRAUTORIZACAO = :NRAUTORIZACAO AND DTCREDITO = :DTCREDITO AND NRORG = :NRORG AND VRBRUTVENDA = :VRBRUTVENDA AND CDLOTEVENDA = :CDLOTEVENDA";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':VRBRUTVENDA', $vrbruto);
            oci_bind_by_name($statement, ':CDLOTEVENDA', $cdlotevenda);
            oci_bind_by_name($statement, ':NRAUTORIZACAO', $autorizacao);
            
        } else{
            $sql = "SELECT COUNT(*) LINHAS FROM RETORIGFINANC WHERE CDNSU = :CDNSU AND NRAUTORIZACAO = :NRAUTORIZACAO AND DTCREDITO = :DTCREDITO AND NRORG = :NRORG";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':CDNSU', $nsu);
            oci_bind_by_name($statement, ':NRAUTORIZACAO', $autorizacao);
        }
		oci_bind_by_name($statement, ':DTCREDITO', $dtcredito);
        oci_bind_by_name($statement, ':NRORG', self::$nrorg);
        
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        
        return intval(oci_fetch_assoc($statement)["LINHAS"]) == 0 ? true : false;
    }

    /*
     * Verifica se o estabelimento informado possui registro na tabela de Estabelimento, e inseri o estabelimento em casos negativos
     *
     * @param conn: oci8 connection object
     * @param estabelecimento: número do estabelecimento informado no relatório
     */
    private static function CheckEstabelimento ($conn, $estabelecimento) {
        $sql = 'SELECT * FROM ESTABELECIMENTO WHERE TO_NUMBER(CDESTABELEC) = TO_NUMBER(:CDESTABELEC)';
        $statement = oci_parse($conn, $sql);
        $EstabelecimentoStrval = strval($estabelecimento);
        oci_bind_by_name($statement, ':CDESTABELEC', $EstabelecimentoStrval);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        if (gettype(oci_fetch_assoc($statement)['NRESTABELEC']) === 'NULL') {
            $nrSeq = Cnc_WS::GenerateNrSeq($conn, 'ESTABELECIMENTO');

            $sql = "INSERT INTO ESTABELECIMENTO (NRESTABELEC, CDESTABELEC, NRORG, IDATIVO) VALUES (:NRESTABELEC, TO_CHAR(TO_NUMBER(:CDESTABELEC)), :NRORG, 'S')";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':NRESTABELEC', $nrSeq);
            $EstabelecimentoStrval = strval($estabelecimento);
            oci_bind_by_name($statement, ':CDESTABELEC', $EstabelecimentoStrval);
            oci_bind_by_name($statement, ':NRORG', self::$nrorg);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);

            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
            
            self::$rowBackCount++;
            self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_WS::makeCommit($conn) : self::$rowBackCount;
        }
    }

    /*
     * Seleciona e retorna o NRESTABELEC de uma linha da tabela Estabelecimento buscando pelo código do estabelecimento
     *
     * @param conn: oci8 connection object
     * @param estabelecimento: número do estabelecimento informado no relatório
     *
     * @return string: número do estabelecimento retornado pelo select
     */
    private static function getNrEstabelec ($conn, $estabelecimento) {
        $sql = "SELECT NRESTABELEC FROM ESTABELECIMENTO WHERE TO_NUMBER(CDESTABELEC) = TO_NUMBER(:CDESTABELEC)";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':CDESTABELEC', $estabelecimento);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        return oci_fetch_row($statement)[0];
    }

    /*
     * Verifica se o CNPJ passado pertence a alguma filial já cadastrada. Se sim, atualiza os campos de filial para o estabelecimento
     * passado.
     *
     * @param conn: oci8 connection object
     * @param cnpj: número do CNPJ da row atual do relatório
     * @param estabelec: número do estabelecimento da row atual do relatório
     */
    private static function CheckCNPJFilial ($conn, $cnpj, $estabelec) {
        $sql = "SELECT CDFILIAL, NMFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI, NRINSJURFILI FROM FILIAL WHERE NRORG = :NRORG AND NRINSJURFILI = :CNPJ";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':NRORG', self::$nrorg);
        oci_bind_by_name($statement, ':CNPJ', $cnpj);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        $fili = oci_fetch_assoc($statement);
        $fili["NMFILIAL"] = empty($fili["NMFILIAL"]) ? "" : $fili["NMFILIAL"];
        
        if ($fili) {
            $sql = "UPDATE ESTABELECIMENTO SET CDFILIAL = :CDFILIAL, NMESTABELEC = :NMESTABELEC, NRCNPJESTABELEC = :CNPJ, CDEMPRESA = :CDEMPRESA, CDINSCESTA = :CDINSCESTA, CDINSCMUNI = :CDINSCMUNI WHERE NRORG = :NRORG AND NRESTABELEC = :NRESTABELEC";
            $statement = oci_parse($conn, $sql);
            oci_bind_by_name($statement, ':CDFILIAL', $fili["CDFILIAL"]);
            oci_bind_by_name($statement, ":NMESTABELEC", $fili["NMFILIAL"]);
            oci_bind_by_name($statement, ':CNPJ', $cnpj);
            oci_bind_by_name($statement, ':CDEMPRESA', $fili["CDEMPRESA"]);
            oci_bind_by_name($statement, ":CDINSCESTA", $fili["CDINSCESTA"]);
            oci_bind_by_name($statement, ':CDINSCMUNI', $fili["CDINSCMUNI"]);
            oci_bind_by_name($statement, ':NRORG', self::$nrorg);
            oci_bind_by_name($statement, ':NRESTABELEC', $estabelec);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            
            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
            
            self::$rowBackCount++;
            self::$rowBackCount = self::$rowBackCount >= 500 ? Cnc_WS::makeCommit($conn) : self::$rowBackCount;
        }
    }
    
    /*
     * Atualiza a CONTROLEACESWS para conter o estabelecimento no qual o WS esteve
     * 
     * @param conn: oci8 connection obj
     * @param acessws: chave primária do controle de acesso atual
     * @param estabelec: estabelecimento que o WS está atualmente tratando
     */
    private static function updateControleAcessWS ($conn, $acessws, $estabelec) {
        $sql = "UPDATE CONTROLEACESWS SET NRESTABELEC = :NRESTABELEC WHERE NRCTRLACESWS = :NRCTRLACESWS";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ":NRESTABELEC", $estabelec);
        oci_bind_by_name($statement, ":NRCTRLACESWS", $acessws);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
    }

    private static function replicaDadosProc ($conn) {
        $sql = "BEGIN REPLICA_DADOS_CNC(TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY'), TO_DATE(:P_DTFINAL, 'DD/MM/YYYY'), :P_NRSEQCONTROLE); END;";
        $statement = oci_parse($conn, $sql);
        oci_bind_by_name($statement, ':P_DTINICIAL', self::$periodIni);
        oci_bind_by_name($statement, ':P_DTFINAL', self::$periodEnd);
        oci_bind_by_name($statement, ':P_NRSEQCONTROLE', self::$nrSeqControle);
        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
        
        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        return $bool;
    }
    
    private static function conciliacao ($conn, $estabelecimento, $dtIni, $dtFim) {
        $sql = "BEGIN CONCILIACAO_CNC (:P_NRESTABELEC, TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY'), TO_DATE(:P_DTFINAL, 'DD/MM/YYYY')); END;";
        $statement = oci_parse($conn, $sql);
        
        $P_DTINICIAL = self::$periodIni;
        $P_DTFINAL = self::$periodEnd;
        
        oci_bind_by_name($statement, ':P_NRESTABELEC', $estabelecimento);
        oci_bind_by_name($statement, ':P_DTINICIAL', $P_DTINICIAL);
        oci_bind_by_name($statement, ':P_DTFINAL', $P_DTFINAL);
        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
        
        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        
        return $bool;
    }

     private static function geraFinanceiro ($conn, $estabelecimento) {
        $sql = "BEGIN GERA_FINANCEIRO_CNC(:P_ESTABELEC, TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY'), TO_DATE(:P_DTFINAL, 'DD/MM/YYYY')); END;";
        $statement = oci_parse($conn, $sql);
        $P_DTINICIAL = self::$periodIni;
        $P_DTFINAL = self::$periodEnd;
        oci_bind_by_name($statement, ':P_ESTABELEC', $estabelecimento);
        oci_bind_by_name($statement, ':P_DTINICIAL', $P_DTINICIAL);
        oci_bind_by_name($statement, ':P_DTFINAL', $P_DTFINAL);
        $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
        
        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        return $bool;
    }
    
    /*
     * Abstração para commit das alterações nas tabelas
     */
    private static function makeCommit ($conn) {
        oci_commit($conn);
        return 0;
    }
    
    /*
     * Implementação simples de um método que se comporta como um zip. Os dois arrays devem ter o mesmo tamanho.
     * 
     * @param a: primeiro array para o zip
     * @param b: segundo array para o zip
     *
     * @return [[String, String]]: array zip-like dos dois arrays parâmetros.
     */
    private static function zipTwo ($companies, $passwords) {
        return array_map(function($company, $password) {
            return array(
                'COMPANY'  => $company,
                'PASSWORD' => $password
            );
        }, $companies, $passwords);
    }
    
    
    /*
     * Funcao abaixo corrige caracteres especiais em produtos por adquirentes
     * 
     * @param a: Conection
     * Infelizmente varios produtos foram homologados com caracteres especiais e apos migrar o servico para o php7 causou varios problemas na chamada da query que busca os produtos por adquirentes.
     */
    private static function ResolveSpecCarac ($conn) {
        try {
            $updates = array(
                '0' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'BANRICOMPRAS PRE-DATADO' 			 WHERE CDPRODUTOADQ = '314'",
                '1' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PLANVALE ALIMENTACAO' 			 WHERE CDPRODUTOADQ = '389'",
                '2' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PLANVALE PREMIACAO' 				 WHERE CDPRODUTOADQ = '390'",
                '3' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'GETNET TITULO' 					 WHERE CDPRODUTOADQ = '410'",
                '4' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PAGSEGURO CARTAO DE CREDITO' 		 WHERE CDPRODUTOADQ = '417'",
                '5' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PAGSEGURO DEBITO ONLINE (TEF)' 	 WHERE CDPRODUTOADQ = '419'",
                '6' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'SAFRA PAY CREDITO' 				 WHERE CDPRODUTOADQ = '423'",
                '7' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'SAFRA PAY DEBITO' 				 WHERE CDPRODUTOADQ = '424'",
                '8' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PAGSEGURO CARTAO DE DEBITO' 		 WHERE CDPRODUTOADQ = '426'",
                '9' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'VEROCHEQUE CREDITO' 				 WHERE CDPRODUTOADQ = '427'",
                '10' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'VEROCHEQUE DEBITO' 				 WHERE CDPRODUTOADQ = '428'",
                '11' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'BEN VISA VALE REFEICAO' 			 WHERE CDPRODUTOADQ = '514'",
                '12' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'OUROCARD AGRO DEBITO' 			 WHERE CDPRODUTOADQ = '536'",
                '13' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'ALELO MULTIBENEFICIOS' 			 WHERE CDPRODUTOADQ = '540'",
                '14' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'MASTER PEDAGIO' 				     WHERE CDPRODUTOADQ = '318'",
                '15' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'ELO CARNE' 				         WHERE CDPRODUTOADQ = '319'",
                '16' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'MASTER CARNE' 				     WHERE CDPRODUTOADQ = '320'",
                '17' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PLANVALE CONVENIO' 				 WHERE CDPRODUTOADQ = '385'",
                '18' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'SOROCRED CREDIARIO' 				 WHERE CDPRODUTOADQ = '416'",
                '19' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'PAGSEGURO DEPOSITO EM CONTA'      WHERE CDPRODUTOADQ = '422'",
                '20' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'ALELO REFEICAO' 					 WHERE CDPRODUTOADQ = '593'",
                '21' => "UPDATE PRODUTOADQ SET NMPRODUTOADQ = 'ALELO ALIMENTACAO' 				 WHERE CDPRODUTOADQ = '594'");
            foreach ($updates as $row) {
                $statement = oci_parse($conn, $row);
                oci_execute($statement, OCI_COMMIT_ON_SUCCESS);
                Cnc_WS::makeCommit($conn);
            }
            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
            
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }
    /*
     * Muda sessao do banco
     * 
     */
    private static function session ($conn) {
        try {
            $querySession = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY'";

            $statement = oci_parse($conn, $querySession);
            oci_execute($statement, OCI_COMMIT_ON_SUCCESS);
            Cnc_WS::makeCommit($conn);
            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
        } catch (\Exception $e) {
            echo($e->getMessage());
        }
    }


}

class AccessInfoInterface {

    protected $idEmpresa;
    protected $pass;
    
    public function __construct($idEmpresa, $pass) {
        $this->idEmpresa = $idEmpresa;
        $this->pass = $pass;
    }
    
    public function getIdEmpresa() {
        return $this->idEmpresa;
    }
        
    public function setIdEmpresa($idEmpresa) {
        $this->idEmpresa = $idEmpresa;
    }
    
    public function getPass() {
        return $this->pass;
    }
        
    public function setPass($pass) {
        $this->pass = $pass;
    }

}

// Chama o metódo principal da classe para executar o WS
Cnc_WS::executeWS();